ENTITY adder is
	PORT (
		a, b : in bit_vector(3 downto 0);
		z : out bit_vector(3 downto 0)
	);
END adder;

ARCHITECTURE adder_arch of adder is
	SIGNAL s: bit_vector(3 downto 0);
BEGIN
	PROCESS(a, b)
	VARIABLE
		cin : bit;
	BEGIN
		cin := '0';
		FOR i IN 0 TO 3 LOOP
			s(i) <= (a(i) XOR b(i)) XOR cin;
			cin := (a(i) AND b(i)) OR (a(i) AND cin) OR (b(i) AND cin);
		END LOOP;

		IF cin = '1' THEN
			z <= "1111";
		ELSE
			z <= s;
		END IF;
	END PROCESS;
END adder_arch;

